//+------------------------------------------------------------------+

//| HedgePL.mq4 |

//| 2006 - Pedz Rodulfo |

//| pedzr@yahoo.com|

//+------------------------------------------------------------------+
// Version 1.0 6/12/06 
// PL is calculated from a reference point BarsNumber in the past
// PL is in Pips for 1 standard lot
// Change HedgeRatio & BarsNumber
//

#property copyright "Pedz Rodulfo"

#property link "pedzr@yahoo.com"

#property indicator_separate_window

#property indicator_buffers 3

#property indicator_color1 Lime
#property indicator_color2 Blue
#property indicator_color3 Red

//---- buffers


extern string ________Long_Symbols________ = "";                    
extern string     Symbol1Long          = "EURJPY";
extern string     Symbol2Long          = "AUDJPY";
extern string     Symbol3Long          = "USDCHF";
extern string     Symbol4Long          = "NZDUSD";
extern string     Symbol5Long          = "USDCAD";
extern string     Symbol6Long          = "EURCHF";
extern string     Symbol7Long          = "GBPCHF";
extern string     Symbol8Long          = "GBPUSD";
extern string ________Short_Symbols________ = ""; 
extern string     Symbol1Short          = "EURUSD";
extern string     Symbol2Short          = "EURGBP";
extern string     Symbol3Short          = "EURAUD";
extern string     Symbol4Short          = "CHFJPY";
extern string     Symbol5Short          = "AUDUSD";

extern double Lots_1 = 0.2; //Default = 1:1.8
extern double Lots_2 = 0.2; //Default = 1:1.8
extern datetime BeginDate =D'2007.08.17 8:00';
extern datetime EndDate= 0 ;
int BeginNumber;
int EndNumber;
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];


//+------------------------------------------------------------------+

//| Custom indicator initialization function |

//+------------------------------------------------------------------+

int init()

{

BeginNumber = iBarShift(NULL,0,BeginDate);
if(EndDate==0) EndDate=TimeCurrent( ); 
EndNumber = iBarShift(NULL,0,EndDate);

//---- indicators

SetIndexStyle(0,DRAW_HISTOGRAM,0,2);
SetIndexStyle(1,DRAW_LINE,0,2);
SetIndexStyle(2,DRAW_LINE,0,2);

SetIndexBuffer(0,ExtMapBuffer1);
SetIndexBuffer(1,ExtMapBuffer2);
SetIndexBuffer(2,ExtMapBuffer3);
SetIndexEmptyValue(0,0);

string short_name = "Hedge P/L";

IndicatorShortName(short_name);

//----

return(1);

}

//+------------------------------------------------------------------+

//| Custor indicator deinitialization function |

//+------------------------------------------------------------------+

int deinit()

{

//----

//----

return(0);

}

//+------------------------------------------------------------------+

//| Custom indicator iteration function |

//+------------------------------------------------------------------+

int start()

{

int pos=BeginNumber; //# of bars to use
double End1,
       End2, 
       End3, 
       End4, 
       End5, 
       End6, 
       End7, 
       End8, 
       End9, 
       End10, 
       End11, 
       End12, 
       End13;

double d1,
       d2,
       d3,
       d4,
       d5,
       d6,
       d7,
       d8,
       d9,
       d10,
       d11,
       d12,
       d13;
double 
       Start1, 
       Start2,
       Start3, 
       Start4,
       Start5, 
       Start6,
       Start7, 
       Start8,
       Start9, 
       Start10,
       Start11, 
       Start12,
       Start13;

  Start1 = iClose(Symbol1Long,0,BeginNumber);
  Start2 = iClose(Symbol2Long,0,BeginNumber); 
  Start3 = iClose(Symbol3Long,0,BeginNumber);
  Start4 = iClose(Symbol4Long,0,BeginNumber); 
  Start5 = iClose(Symbol5Long,0,BeginNumber);
  Start6 = iClose(Symbol6Long,0,BeginNumber); 
  Start7 = iClose(Symbol7Long,0,BeginNumber);
  Start8 = iClose(Symbol8Long,0,BeginNumber); 

  Start9 = iClose(Symbol1Short,0,BeginNumber);           
  Start10 = iClose(Symbol2Short,0,BeginNumber);
  Start11 = iClose(Symbol3Short,0,BeginNumber);           
  Start12 = iClose(Symbol4Short,0,BeginNumber);
  Start13 = iClose(Symbol5Short,0,BeginNumber);           


while(pos>=EndNumber)
{
  End1 = iClose(Symbol1Long,0,pos);           
  End2 = iClose(Symbol2Long,0,pos);
  End3 = iClose(Symbol3Long,0,pos);           
  End4 = iClose(Symbol4Long,0,pos);
  End5 = iClose(Symbol5Long,0,pos);           
  End6 = iClose(Symbol6Long,0,pos);
  End7 = iClose(Symbol7Long,0,pos);           
  End8 = iClose(Symbol8Long,0,pos);

  End9 = iClose(Symbol1Short,0,pos);           
  End10 = iClose(Symbol2Short,0,pos);
  End11 = iClose(Symbol3Short,0,pos);           
  End12 = iClose(Symbol4Short,0,pos);
  End13 = iClose(Symbol5Short,0,pos);           
  
  d1=Lots_1*((End1-Start1))*PipCost(Symbol1Long);
  d2=Lots_1*((End2-Start2))*PipCost(Symbol2Long) ;
  d3=Lots_1*((End3-Start3))*PipCost(Symbol3Long);
  d4=Lots_1*((End4-Start4))*PipCost(Symbol4Long) ;
  d5=Lots_1*((End5-Start5))*PipCost(Symbol5Long);
  d6=Lots_1*((End6-Start6))*PipCost(Symbol6Long) ;
  d7=Lots_1*((End7-Start7))*PipCost(Symbol7Long);
  d8=Lots_1*((End8-Start8))*PipCost(Symbol8Long) ;

  d9 =Lots_2*((End9-Start9))*PipCost(Symbol1Short);
  d10=Lots_2*((End10-Start10))*PipCost(Symbol2Short) ;
  d11=Lots_2*((End11-Start11))*PipCost(Symbol3Short);
  d12=Lots_2*((End12-Start12))*PipCost(Symbol4Short) ;
  d13=Lots_2*((End13-Start13))*PipCost(Symbol5Short);
    
  ExtMapBuffer1[pos]= (d1+d2+d3+d4+d5+d6+d7+d8)-(d9+d10+d11+d12+d13);
  ExtMapBuffer2[pos]= (d1+d2+d3+d4+d5+d6+d7+d8);
  ExtMapBuffer3[pos]= -(d9+d10+d11+d12+d13);
  
  pos--;
}


return(0);

}

//+------------------------------------------------------------------+
//+--------- --------- --------- --------- --------- --------- ----+
//+ Calculate cost in USD of 1pip of given symbol
//+--------- --------- --------- --------- --------- --------- ----+
double PipCost (string TradeSymbol) {
double Base, Cost;
string TS_13, TS_46, TS_4L;
string USD="USD";
TS_13 = StringSubstr (TradeSymbol, 0, 3);
TS_46 = StringSubstr (TradeSymbol, 3, 3);
TS_4L = StringSubstr (TradeSymbol, 3, StringLen(TradeSymbol)-3);

Base = MarketInfo (TradeSymbol, MODE_LOTSIZE) * MarketInfo (TradeSymbol, 
MODE_POINT);
if ( TS_46 == "USD" )
Cost = Base;
else if ( TS_13 == "USD" )
Cost = Base / MarketInfo (TradeSymbol, MODE_BID);
else if ( PairExists ("USD"+TS_4L) )
Cost = Base / MarketInfo ("USD"+TS_4L, MODE_BID);
else
Cost = Base * MarketInfo (TS_46+USD , MODE_BID);

return(Cost) ;
}
//+--------- --------- --------- --------- --------- --------- ----+
//+ Returns true if given symbol exists
//+--------- --------- --------- --------- --------- --------- ----+
bool PairExists (string TradeSymbol) {
return ( MarketInfo (TradeSymbol, MODE_LOTSIZE) > 0 );
}


